#include "asm/vmm-offsets.h"

/* Itanium 2 */
.macro __afterburn_call func
	mov r7=ar.pfs
	brl.call.sptk.many b2=\func
	;;
	mov ar.pfs=r7
.endm
/**/
/*
.macro __afterburn_call func
	movl r7=\func
	;;
	mov b2=r7
	mov r7=ar.pfs
	;;
	br.call.sptk.many b2=b2
	;;
	mov ar.pfs=r7
.endm
*/
.macro __afterburn_break_noarg num
	break \num
	add r4=0x10,r4
	;;
	mov b2=r4
	br.sptk.many b2
	;;
.endm

.macro __afterburn_break num
	break \num
	add r4=0x20,r4
	;;
	mov b2=r4
	br.sptk.many b2
	;;
.endm

.proc burn_deliver_interrupt
burn_deliver_interrupt:
	/* check psr.i */
	mov r5=__afterburn_cpu+CPU_PSR
	;;
	ld8 r5=[r5]
	;;
	tbit.nz p6,p0=r5,14
	;;

	/* check cr.ivr > in_service_irq */
(p6)	mov r5=__afterburn_cpu+CPU_CR0+8*65
(p6)	mov r6=__afterburn_cpu+CPU_IN_SERVICE_IRQ
	;;
(p6)	ld8 r5=[r5]
(p6)	ld4 r6=[r6]
	;;
(p6)	cmp.gt p6,p0=r5,r6
	;;

	/* check (cr.ivr >> 4) > (tpr >> 4) - includes mmi bit */
(p6)	mov r6=__afterburn_cpu+CPU_CR0+8*66
	;;
(p6)	ld8 r6=[r6]
(p6)	shr.u r5=r5,4
	;;
(p6)	shr.u r6=r6,4
	;;
(p6)	cmp.gt p6,p0=r5,r6
	;;

	/* deliver interrupt via hypervisor */
(p6)	break BREAK_DELIVER_IRQ
	mov pr=r7,-1
	;;
	mov b2=r4
	br.sptk.many b2
	;;
.endp burn_deliver_interrupt

.macro __afterburn_check_interrupts
	mov r5=__afterburn_cpu+CPU_IRQ_PENDING
	;;
	ld4 r5=[r5]
	mov r7=pr
	;;
	cmp.ne p6,p0=r5,r0
(p6)	br.spnt.many burn_deliver_interrupt
	;;
	mov pr=r7,-1
	;;
	mov b2=r4
	br.sptk.many b2
	;;
.endm

.macro __afterburn_bank_switch bank
#if 1
	mov r5=__afterburn_cpu+CPU_PSR
	;;
	ld8 r5=[r5]
	mov r7=pr
	;;
.if \bank == 1
	tbit.z p6,p0=r5,44
.else
	tbit.nz p6,p0=r5,44
.endif
	;;
(p6)	mov r5=__afterburn_cpu+CPU_SAVEDBANK0+(1-\bank)*8*16
(p6)	mov r6=__afterburn_cpu+CPU_SAVEDBANK0+(1-\bank)*8*16+8
	;;
(p6)	st8 [r5] = r16, 16
(p6)	st8 [r6] = r17, 16
	;;
(p6)	st8 [r5] = r18, 16
(p6)	st8 [r6] = r19, 16
	;;
(p6)	st8 [r5] = r20, 16
(p6)	st8 [r6] = r21, 16
	;;
(p6)	st8 [r5] = r22, 16
(p6)	st8 [r6] = r23, 16
	;;
(p6)	st8 [r5] = r24, 16
(p6)	st8 [r6] = r25, 16
	;;
(p6)	st8 [r5] = r26, 16
(p6)	st8 [r6] = r27, 16
	;;
(p6)	st8 [r5] = r28, 16
(p6)	st8 [r6] = r29, 16
	;;
(p6)	st8 [r5] = r30
(p6)	st8 [r6] = r31
(p6)	mov r5=__afterburn_cpu+CPU_SAVEDBANK0+\bank*8*16
(p6)	mov r6=__afterburn_cpu+CPU_SAVEDBANK0+\bank*8*16+8
	;;
(p6)	ld8 r16 = [r5], 16
(p6)	ld8 r17 = [r6], 16
	;;
(p6)	ld8 r18 = [r5], 16
(p6)	ld8 r19 = [r6], 16
	;;
(p6)	ld8 r20 = [r5], 16
(p6)	ld8 r21 = [r6], 16
	;;
(p6)	ld8 r22 = [r5], 16
(p6)	ld8 r23 = [r6], 16
	;;
(p6)	ld8 r24 = [r5], 16
(p6)	ld8 r25 = [r6], 16
	;;
(p6)	ld8 r26 = [r5], 16
(p6)	ld8 r27 = [r6], 16
	;;
(p6)	ld8 r28 = [r5], 16
(p6)	ld8 r29 = [r6], 16
	;;
(p6)	ld8 r30 = [r5]
(p6)	ld8 r31 = [r6]
	mov r6=__afterburn_cpu+CPU_PSR
	;;
	ld8 r5=[r6]
	mov pr=r7,-1
	;;
	dep r5=-\bank,r5,44,1
	;;
	st8 [r6]=r5
	add r4=0x10,r4
	;;
	mov b2=r4
	br.sptk.many b2
	;;
#else
	bsw.\bank
	add r4=0x10,r4
	;;
	mov b2=r4
	br.sptk.many b2
	;;
#endif
.endm

.global burn_rfi
.proc burn_rfi
burn_rfi:
/*	mov r4=ip*/
	mov r5=__afterburn_cpu+CPU_CR0+23*8	/* IFS */
	;;
	ld8 r5=[r5]
	mov r7=pr
	;;
	tbit.nz p63,p0=r5,63	/* interruption here could clobber r7/p6 */
	;;
(p63)	br.spnt.many 1f
	;;
	mov pr=r7,-1
	break BREAK_RFI
	;;
1:
	alloc r5=ar.pfs,0,0,0,0
	mov pr=r7,-1
	break BREAK_RFI
	;;
.endp burn_rfi

.proc burn_read_cfm
burn_read_cfm:
	mov r5=ar.pfs
	br.ret.sptk.many b2
	;;
.endp burn_read_cfm

.global burn_cover
.proc burn_cover
burn_cover:
#if 1
	mov r7=ar.pfs
	br.call.sptk.few b2=burn_read_cfm
	;;
	dep.z r5=r5,0,38
	mov ar.pfs=r7
	;;
	mov r7=__afterburn_cpu+CPU_CFLE
	;;
	ld4 r6=[r7]
	;;
	cmp.eq p5,p6=r6,r0
	;; 
(p6)	mov r6=__afterburn_cpu+CPU_CR0+23*8 /* IFS */ 
(p6)	dep r5=-1,r5,63,1
	;;
(p6)	st8 [r6]=r5
	/* beware this can't be reexecuted */
	cover
	;;
	mov r6=1
	;;
	st4 [r7]=r6
	add r4=0x10,r4
	;;
	mov b2=r4
	br.sptk.many b2
	;;
#else
	 __afterburn_break_noarg BREAK_COVER
#endif
.endp burn_cover

.global burn_bsw_0
.proc burn_bsw_0
burn_bsw_0:
	__afterburn_bank_switch 0
	/* __afterburn_break_noarg BREAK_BSW_0 */
.endp burn_bsw_0

.global burn_bsw_1
.proc burn_bsw_1
burn_bsw_1:
	__afterburn_bank_switch 1
	/* __afterburn_break_noarg BREAK_BSW_1 */
.endp burn_bsw_1

.global burn_read_ivr
.proc burn_read_ivr
burn_read_ivr:
	__afterburn_break_noarg BREAK_READ_IVR
.endp burn_read_ivr

.global burn_write_itm
.proc burn_write_itm
burn_write_itm:
#if 0
	__afterburn_call vmm_write_itm
	add r4=0x20,r4
	;;
	mov b2=r4
	br.sptk.many b2
	;;
#else
	__afterburn_break BREAK_WRITE_ITM
#endif
.endp burn_write_itm

/* N.B. dfh check not restartable! */
.global burn_write_psr
.proc burn_write_psr
burn_write_psr:
#if 0
	psr.l = r5
	add r4=0x20,r4
	;;
	mov b2=r4
	br.sptk.many b2
#else
	mov r6=__afterburn_cpu+CPU_PSR
	;;
	ld8 r7=[r6]
	shl r5=r5,32
	;;
	mix4.l r5=r7,r5
	;;
	st8 [r6]=r5
	;;
	mov r6=pr
	/* psr.dfh 0 -> 1 ? */
	tbit.nz p6,p0=r5,19
	;;
(p6)	tbit.z p6,p0=r7,19
	;;
(p6)	break BREAK_SET_DFH
	;;
	mov pr=r6,-1
	dep.z r5=r5,0,6
	;;
	mov psr.um = r5
	add r4=0x20,r4
	__afterburn_check_interrupts
#endif
.endp burn_write_psr

.global burn_set_dfh
.proc burn_set_dfh
burn_set_dfh:
#if 1
	__afterburn_break_noarg BREAK_SET_DFH
#else
	__afterburn_call vmm_set_dfh
	 add r4=0x10,r4
	;;
	mov b2=r4
	br.sptk.many b2
	;;
#endif
.endp burn_set_dfh

.global burn_enable_interrupts
.proc burn_enable_interrupts
burn_enable_interrupts:
#if 1
	mov r6=__afterburn_cpu+CPU_PSR
	;;
	ld8 r5=[r6]
	;;
	dep r5=-1,r5,14,1
	;;
	st8 [r6]=r5
	add r4=0x10,r4
	__afterburn_check_interrupts
#else
	ssm psr.i
	add r4=0x10,r4
	;;
	mov b2=r4
	br.sptk.many b2
	;;
#endif
.endp burn_enable_interrupts

.global burn_thash
.proc burn_thash
burn_thash:
#if 1
	/* r6=cr.pta */
	mov r6=__afterburn_cpu+CPU_CR0+8*8
	mov r7=r2
	;;
	ld8 r6=[r6]

	/* r2=region */
	shr.u r2=r5,61
	;;

	/* deposit region into r6 */
	dep r6=r2,r6,61,3

	/* r2=rr[r2].ps */
	shl r2=r2,3
	;;
	add r2=__afterburn_cpu+CPU_RR0,r2
	/* clear bottom 15 bits of r6 */
	dep r6=0,r6,0,15
	;;
	ld8 r2=[r2]
	/* clear region bits in r5 */
	dep r5=0,r5,61,3
	;;
	extr.u r2=r2,2,6
	;;
	/* r5>>=ps */
	shr.u r5=r5,r2
	;;
	/* res=r6+(r5<<3) */
	mov r2=r7
	shladd r5=r5,3,r6
#else
	mov r5=pmc[r5]
#endif
	add r4=0x20,r4
	;;
	mov b2=r4
	br.sptk.many b2
	;;
.endp burn_thash

.global burn_tpa
.proc burn_tpa
burn_tpa:
#if 0
	__afterburn_call vmm_tpa
	add r4=0x20,r4
	;;
	mov b2=r4
	br.sptk.many b2
	;;
#else
	__afterburn_break BREAK_TPA
#endif
.endp burn_tpa

.global burn_write_rr
.proc burn_write_rr
burn_write_rr:
#if 0
	mov r7=__afterburn_cpu+CPU_RR0
	shr.u r5=r5,61
	;;
	shladd r7=r5,3,r7
	;;
	st8 [r7]=r6
	mov r7=(12<<2)|1
	;;
	dep r6=r7,r6,0,8
	__afterburn_call vmm_write_rr
	add r4=0x20,r4
	;;
	mov b2=r4
	br.sptk.many b2
	;;
#elif 0
	mov rr[r5]=r6
	add r4=0x20,r4
	;;
	mov b2=r4
	br.sptk.many b2
	;;
#else
	 __afterburn_break BREAK_WRITE_RR
#endif

.endp burn_write_rr

.global burn_tlbop
.proc burn_tlbop
burn_tlbop:
	__afterburn_break BREAK_TLBOP
.endp burn_tlbop

.global burn_hint_pause
.proc burn_hint_pause
burn_hint_pause:
	__afterburn_break_noarg BREAK_PAUSE
.endp burn_hint_pause
