
.macro __afterburn_call_0_0 pr,func
{.mib
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	br.sptk.many \func
	;;
}
(\pr)	mov r4=r0
	;;
.endm

.macro __afterburn_call_1_0 pr,func,src
{.mii
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	mov r5=\src
}
{.mmb
(\pr)	nop.m 0x0
(\pr)	nop.m 0x0
(\pr)	br.sptk.many \func
	;;
}
(\pr)	mov r4=r0
	;;
.endm

.macro __afterburn_call_0_1 pr,func,dst
{.mib
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	br.sptk.many \func
	;;
}
(\pr)	mov \dst=r5
(\pr)	mov r4=r0
	;;
.endm

.macro __afterburn_call_1_1 pr,func,src,dst
{.mii
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	mov r5=\src
}
{.mmb
(\pr)	nop.m 0x0
(\pr)	nop.m 0x0
(\pr)	br.sptk.many \func
	;;
}
(\pr)	mov \dst=r5
(\pr)	mov r4=r0
	;;
.endm

.macro __afterburn_call_2_0 pr,func,src1,src2
{.mii
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	mov r5=\src1
}
{.mmb
(\pr)	mov r6=\src2
(\pr)	nop.m 0x0
(\pr)	br.sptk.many \func
	;;
}
(\pr)	mov r4=r0
	;;
.endm

.macro __afterburn_call_3_0 pr,func,src1,src2,src3
{.mii
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	mov r5=\src1
}
{.mmb
(\pr)	mov r6=\src2
(\pr)	mov r7=\src3
(\pr)	br.sptk.many \func
	;;
}
(\pr)	mov r4=r0
	;;
.endm

/* don't need to come back! */
.macro emul_rfi pr=p0
(\pr)	br.sptk.many burn_rfi
	;;
.endm

.macro emul_bsw_0 pr=p0
	__afterburn_call_0_0 \pr,burn_bsw_0
.endm

.macro emul_bsw_1 pr=p0
	__afterburn_call_0_0 \pr,burn_bsw_1
.endm

.macro emul_thash pr=p0,dst,src
	__afterburn_call_1_1 \pr,burn_thash,\src,\dst
.endm

.macro emul_ttag pr=p0,dst,src
	__afterburn_call_1_1 \pr,burn_ttag,\src,\dst
.endm

.macro emul_tpa pr=p0,dst,src
	__afterburn_call_1_1 \pr,burn_tpa,\src,\dst
.endm

.macro emul_cover pr=p0
	__afterburn_call_0_0 \pr,burn_cover
.endm

.macro emul_read_ivr pr=p0,dst
	__afterburn_call_0_1 \pr,burn_read_ivr,\dst
.endm

.macro emul_write_itm pr=p0,src
	__afterburn_call_1_0 \pr,burn_write_itm,\src
.endm

.macro emul_write_psr pr=p0,src
	__afterburn_call_1_0 \pr,burn_write_psr,\src
.endm

.macro emul_enable_interrupts pr=p0
	__afterburn_call_0_0 \pr,burn_enable_interrupts
.endm

.macro emul_set_dfl pr=p0
	__afterburn_call_0_0 \pr,burn_set_dfl
.endm

.macro emul_set_dfh pr=p0
	__afterburn_call_0_0 \pr,burn_set_dfh
.endm

.macro emul_write_rr pr=p0,rr,src
	__afterburn_call_2_0 \pr,burn_write_rr,\rr,\src
	
.endm


/* TLB management operations are multiplexed over burn_tlbop
   since they are all routed to the hypervisor MM subsystem */

.macro emul_itc_d pr=p0,src
	__afterburn_call_3_0 \pr,burn_tlbop,0,\src,-1
.endm

.macro emul_itc_i pr=p0,src
	__afterburn_call_3_0 \pr,burn_tlbop,1,\src,-1
.endm

.macro emul_itr_d pr=p0,dtr,src
	__afterburn_call_3_0 \pr,burn_tlbop,2,\src,\dtr
.endm

.macro emul_itr_i pr=p0,itr,src
	__afterburn_call_3_0 \pr,burn_tlbop,3,\src,\itr
.endm

.macro emul_ptc_l pr=p0,va,sz
	__afterburn_call_3_0 \pr,burn_tlbop,4,\va,\sz
.endm

.macro emul_ptc_g pr=p0,va,sz
	__afterburn_call_3_0 \pr,burn_tlbop,5,\va,\sz
.endm

.macro emul_ptc_ga pr=p0,va,sz
	__afterburn_call_3_0 \pr,burn_tlbop,6,\va,\sz
.endm

.macro emul_ptr_d pr=p0,va,sz
	__afterburn_call_3_0 \pr,burn_tlbop,7,\va,\sz
.endm

.macro emul_ptr_i pr=p0,va,sz
	__afterburn_call_3_0 \pr,burn_tlbop,8,\va,\sz
.endm

.macro emul_ptc_e pr=p0,src
	__afterburn_call_2_0 \pr,burn_tlbop,9,\src
.endm


/* remaining ones are trivial enough to be implemented inline */

.macro emul_read_cr pr=p0,dst,cr
(\pr)	add \dst=L___afterburn_cpu+L_CPU_CR0+8*\cr,r0
	;;
(\pr)	ld8 \dst=[\dst]
.endm

.macro emul_write_cr pr=p0,cr,src
{.mii
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	add r5=L___afterburn_cpu+L_CPU_CR0+8*\cr,r0
}
	;;
(\pr)	st8 [r5]=\src
(\pr)   mov r4=r0
	;;
.endm

.macro emul_write_eoi pr=p0
{.mii
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	add r5=L___afterburn_cpu+L_CPU_IN_SERVICE_IRQ,r0
	;;
}
(\pr)	st4 [r5]=r0
(\pr)	mov r4=r0
	;;
.endm

.macro emul_read_kr pr=p0,dst,kr
(\pr)	add \dst=L___afterburn_cpu+L_CPU_KR0+8*\kr,r0
	;;
(\pr)	ld8 \dst=[\dst]
.endm

.macro emul_write_kr pr=p0,kr,src
{.mii
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	add r5=L___afterburn_cpu+L_CPU_KR0+8*\kr,r0
	;;
}
(\pr)	st8 [r5]=\src
(\pr)	mov r4=r0
	;;
.endm

.macro emul_write_itc pr=p0,src
.endm

.macro emul_read_rr pr=p0,dst,rr
{.mii
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	add r5=L___afterburn_cpu+L_CPU_RR0,r0
}
(\pr)	shr.u r6=\rr,61
	;;
(\pr)	shladd \dst=r6,3,r5
	;;
(\pr)	ld8 \dst=[\dst]
	mov r4=0
.endm

.macro emul_read_psr pr=p0,dst
{.mii
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	add \dst=L___afterburn_cpu+L_CPU_PSR,r0
}
(\pr)	mov r5=psr.um
	;;
(\pr)	ld8 \dst=[\dst]
	;;
(\pr)	dep \dst=r5,\dst,0,6
(\pr)	mov r4=r0
	;;
.endm

.macro emul_sm_load pr=p0
{.mii
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	add r5=L___afterburn_cpu+L_CPU_PSR,r0
}
	;;
(\pr)	ld8 r6=[r5]
	;;
.endm

.macro emul_ssm pr=p0,bit
(\pr)	dep r6=-1,r6,\bit,1
	;;
.endm

.macro emul_rsm pr=p0,bit
(\pr)	dep r6=0,r6,\bit,1
	;;
.endm

.macro emul_sm_store pr=p0
(\pr)	st8 [r5]=r6
(\pr)	mov r4=r0
	;;
.endm

.macro emul_sum pr=p0,mask
(\pr)	sum \mask
.endm

.macro emul_rum pr=p0,mask
(\pr)	rum \mask
.endm

.macro emul_srlz pr=p0
.endm

.macro real_cover
	cover
.endm
.macro emul_fc pr=p0,src
(\pr)	fc	\src
.endm

/* Ignore NAT bits for now... */
.macro emul_st8_spill_r pr=p0,idx,incr,reg
{.mii
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	mov r5=L___afterburn_cpu+L_CPU_GR\reg
	;;
}
(\pr)	ld8 r5=[r5]
	;;
(\pr)	st8.spill [\idx]=r5
(\pr)	mov r4=r0
(\pr)	add \idx=\incr,\idx
	;;
.endm

.macro emul_ld8_fill_r pr=p0,idx,incr,reg
{.mii
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	mov r5=L___afterburn_cpu+L_CPU_GR\reg
}
(\pr)	ld8.fill r6=[\idx]
	;;
(\pr)	st8 [r5]=r6
(\pr)	mov r4=r0
(\pr)	add \idx=\incr,\idx	
;;
.endm

.macro emul_clear_reg pr=p0,reg
{.mii
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	mov r5=L___afterburn_cpu+L_CPU_GR\reg
	;;
}
(\pr)	st8 [r5]=r0
(\pr)	mov r4=r0
	;;
.endm
	
.macro emul_clear_r4 pr=p0
	;;
	emul_clear_reg \pr,reg=4
	;;
	mov r4=r0
.endm

.macro emul_clear_r5 pr=p0
	;;
	emul_clear_reg \pr,reg=5
	;;
	mov r5=r0
	;;
.endm

.macro emul_clear_r6 pr=p0
	;;
	emul_clear_reg \pr,reg=6 
	;;
	mov r6=r0
.endm

.macro emul_clear_r7 pr=p0
	;;
	emul_clear_reg \pr,reg=7
	;; 
	mov r7=r0
.endm

.macro emul_read_b2 pr=p0,dest
	movl	\dest=L___afterburn_cpu+L_CPU_B2
	;;
	ld8 \dest=[\dest]
.endm

.macro emul_write_b2 pr=p0,src
{.mii
(\pr)	nop.m 0x0
(\pr)	mov r4=ip
(\pr)	mov r5=L___afterburn_cpu+L_CPU_B2
	;;
}
(\pr)	st8 [r5]=\src
	;;
(\pr)   mov b2=\src
(\pr)	mov r4=r0
.endm

/*
 * Can't use an out-of-line function for this because we 
 * need to save r4 and b2
 */
.macro emul_epc
	mov r25=L___afterburn_cpu+L_CPU_PSR 
	mov r26=r4
	mov r27=r5
	mov r28=r6
	;; 
	ld8 r24=[r25]		/* simulated PSR */
	mov r30=b2
	;;
{ .mib
	mov r29=r7
	dep r24=0,r24,32,2	/* set psr.cpl to 0 */
	epc
	;;
}
	;; 
	st8 [r25]=r24		/* save the updated PSR */
	;; 
	mov r4=ip
	add r5=L_CPU_GR4-L_CPU_PSR,r25
	add r6=L_CPU_GR5-L_CPU_PSR,r25
	;; 
	;;
	st8 [r5]=r26,16		/* old r4 */
	st8 [r6]=r27,16		/* old r5 */
	;; 
	st8 [r5]=r28,16		/* old r6 */
	st8 [r6]=r29,16		/* old r7 */
	;;
	st8 [r5]=r30		/* old b2 */
	mov r4=0
	;;
.endm

.macro emul_unepc
	mov r4=ip
	movl r5=L___afterburn_cpu+L_CPU_PSR
	;;
	ld8 r6=[r5]		/* PSR */
	add r24=L_CPU_GR4-L_CPU_PSR,r5
	add r25=L_CPU_GR5-L_CPU_PSR,r5
	;;
	ld8 r26=[r24],16	/* gr4 */
	ld8 r27=[r25],16	/* gr5 */
	dep r6=-1,r6,32,2	/* Set to user privilege (CPL 3) */
	;;
	ld8 r28=[r24],16	/* gr6 */
	ld8 r29=[r25],16	/* gr7 */
	;;
	ld8 r30=[r24]		/* b2 */
	st8 [r5]=r6		/*  Now in "user" mode */	
	;;
	mov b2=r30
	mov r7=r29
	mov r6=r28
	mov r5=r27
	mov r4=r26
	;;
.endm

.macro emul_pause
	__afterburn_call_0_0 p0,burn_hint_pause
.endm
	