#include <stdio.h>

unsigned long
get_itc_freq(void)
{
	char buf[100];
	FILE *fp;
	unsigned long m, n;
	int x;

	fp = fopen("/proc/cpuinfo", "r");
	if (fp == NULL) {
		fprintf(stderr, "Cannot open /proc/cpuinfo; Using compiled-in cpu frequency %lu\n", CPU_FREQ);
		return CPU_FREQ; /* guess */
	}

	while (fgets(buf, sizeof buf, fp)) {
		x = sscanf(buf, "itc MHz : %lu.%lu", &m, &n);
		if (x == 2) {
			fprintf(stderr, "CPU frequency is %lu\n", m*1000000 + n);
			return m * 1000000 + n;
		}
	}
	fprintf(stderr, "Didn't find any  itc MHz lines in /proc/cpuinfo; using compiled-in default of %lu\n", CPU_FREQ);
	return CPU_FREQ;
}

	
