#include "stddef.h"
#include "vmlayout.h"
#include "vm.h"

#define DEFINE(sym, val) \
        asm volatile("\n->" #sym " %0 " #val : : "i" (val))

#define BLANK() asm volatile("\n->" : : )
void x(void) 
{
	DEFINE(CPU_SIZE, sizeof (struct cpu));
	DEFINE(CPU_PSR, offsetof(struct cpu, psr));
	DEFINE(CPU_CR0, offsetof(struct cpu, cr[0]));
	DEFINE(CPU_KR0, offsetof(struct cpu, kr[0]));
	DEFINE(CPU_KR1, offsetof(struct cpu, kr[1]));
	DEFINE(CPU_KR2, offsetof(struct cpu, kr[2]));
	DEFINE(CPU_KR3, offsetof(struct cpu, kr[3]));
	DEFINE(CPU_KR4, offsetof(struct cpu, kr[4]));
	DEFINE(CPU_KR5, offsetof(struct cpu, kr[5]));
	DEFINE(CPU_KR6, offsetof(struct cpu, kr[6]));
	DEFINE(CPU_KR7, offsetof(struct cpu, kr[7]));
	DEFINE(CPU_GR4, offsetof(struct cpu, gr[0]));
	DEFINE(CPU_GR5, offsetof(struct cpu, gr[1]));
	DEFINE(CPU_GR6, offsetof(struct cpu, gr[2]));
	DEFINE(CPU_GR7, offsetof(struct cpu, gr[3]));
	DEFINE(CPU_RR0, offsetof(struct cpu, rr[0]));
	DEFINE(CPU_RR1, offsetof(struct cpu, rr[1]));
	DEFINE(CPU_RR2, offsetof(struct cpu, rr[2]));
	DEFINE(CPU_RR3, offsetof(struct cpu, rr[3]));
	DEFINE(CPU_RR4, offsetof(struct cpu, rr[4]));
	DEFINE(CPU_RR5, offsetof(struct cpu, rr[5]));
	DEFINE(CPU_RR6, offsetof(struct cpu, rr[6]));
	DEFINE(CPU_RR7, offsetof(struct cpu, rr[7]));
	DEFINE(CPU_SAVEDBANK0, offsetof(struct cpu, saved_bank[0]));
	DEFINE(CPU_CFLE, offsetof(struct cpu, cfle));
	DEFINE(CPU_ID, offsetof(struct cpu, id));
	DEFINE(CPU_IRQ_PENDING, offsetof(struct cpu, irq_pending));
	DEFINE(CPU_IN_SERVICE_IRQ, offsetof(struct cpu, in_service_irq));
	DEFINE(CPU_B2, offsetof(struct cpu, saved_b2));
	DEFINE(CPU_B6, offsetof(struct cpu, saved_b6));
	BLANK();
	DEFINE(__afterburn_cpu, CPUADDR);
	BLANK();

	DEFINE(BREAK_SSC, 0x80001);
	DEFINE(BREAK_COVER, 0x80002);
	DEFINE(BREAK_HALT, 0x80003);
	BLANK();
	DEFINE(BREAK_TLBOP, 0x80006);
	DEFINE(BREAK_WRITE_RR, 0x80007);
	DEFINE(BREAK_SET_DFH, 0x80008);
	DEFINE(BREAK_SSM_PSR_I, 0x80009);
	DEFINE(BREAK_BSW_0, 0x80010);
	DEFINE(BREAK_BSW_1, 0x80011);
	DEFINE(BREAK_READ_IVR, 0x80012);
	DEFINE(BREAK_WRITE_ITM, 0x80013);
	DEFINE(NREAK_THASH, 0x80014);
	DEFINE(BREAK_TPA, 0x80015);
	DEFINE(BREAK_WRITE_PSR_L, 0x80016);
	BLANK();

	DEFINE(BREAK_RFI, 0x80020);
	DEFINE(BREAK_DELIVER_IRQ, 0x80021);
	BLANK();

	DEFINE(BREAK_PAUSE, 0x80022);
	BLANK();

	DEFINE(BREAK_DEBUG, 0x80000);

	BLANK();
	DEFINE(BURN_UNEPC, GATEADDR);
}
