/* aio.c */
int queueio(int fd, int seqno, int nreq, off_t offset, int is_write, struct disk_req *req);
void aio_init(int keep_files);
void aio_shutdown(void);
int aio_getcompletion(void);
int aio_wait_completion(struct disk_stat *ds);
/* backtrace.c */
void backtrace(struct sigcontext *sc);
/* bootparam.c */
void *get_bootparams(unsigned long lowmem, unsigned long highmem, char *cmd_line);
/* cpuinfo.c */
unsigned long get_itc_freq(void);
/* emu.c */
unsigned long read_register(struct sigcontext *sc, unsigned int regno);
void write_register(struct sigcontext *sc, unsigned int regno, unsigned long value);
void write_psr(struct sigcontext *sc, unsigned long value);
void emu_bsw(struct sigcontext *sc, unsigned int target_bank);
void emu_cover(struct sigcontext *sc);
void emu_tpa(struct sigcontext *sc, int src, int dst);
void emu_M0(struct sigcontext *sc, unsigned long instr);
void tlbop(struct sigcontext *sc, int code, unsigned int r0, unsigned int r1);
void emu_write_rr(struct sigcontext *sc, int rgnreg, int valuereg);
void emu_M1(struct sigcontext *sc, unsigned long instr);
void emu_B0(struct sigcontext *sc, unsigned long instr);
void emu_priv(struct sigcontext *sc);
void emu_store_PIB(struct sigcontext *sc, unsigned long addr);
/* exception.c */
void deliver_exception(struct sigcontext *sc, unsigned long vector, unsigned long isr);
void check_interrupts(struct sigcontext *sc);
void deliver_interrupt(struct sigcontext *sc, unsigned int irq);
void clear_interrupt(unsigned int irq);
/* gen-cpu.c */
void x(void);
/* getpid.c */
pid_t getpid(void);
/* ipc.c */
void ipc_init(void);
void ipc_send_reply(int node, unsigned char type);
void ipc_send_fetch_reply(int node, unsigned long pa, int is_write);
int ipc_handle_async(struct sigcontext *sc, int fd);
void ipc_send(int node, struct request *request);
void ipc_recv(struct sigcontext *sc);
void ipc_call(struct sigcontext *sc, int node, struct request *request);
void ipc_broadcast(struct sigcontext *sc, unsigned long mask, struct request *request);
/* main.c */
pid_t vm_clone(void);
void dump_regs(struct sigcontext *sc);
void dump_cpu(void);
void hexdump(unsigned char *p, int len);
void dump_maps(void);
void dump_stats(void);
void vm_ssc_shutdown(void);
void vm_shutdown(void);
void Usage(void);
void vm_ssc_shutdown(void);
void vm_panic(struct sigcontext *sc, const char *fmt, ...) __attribute__ ((format(printf, 2, 3), noreturn));
void vm_perror(char *string, ...)  __attribute__ ((format(printf, 1, 2)));
int main(int argc, char *argv[]);
/* memcpy.c */
void *memcpy(void *dest, const void *src, size_t n);
/* memset.c */
void *memset(void *s, int c, size_t n);
/* mm.c */
int tlb_insert(unsigned long pte, int pinned);
void tlb_purge(unsigned long va, unsigned long itir);
void tlb_purge_global(struct sigcontext *sc, unsigned long va, unsigned long itir);
void tlb_purge_region(unsigned int region);
void tlb_purge_all(void);
unsigned long thash(unsigned long addr);
unsigned long ttag(unsigned long addr);
unsigned long tpa(unsigned long addr);
void mm_init(int keep_files);
void mm_fault(struct sigcontext *sc, unsigned long address, unsigned long isr, int access_fault);
void set_asid(int, unsigned);
void as_init(void);
void *mmapall(void *start, size_t length, int prot, int flags,
	       int fd, off_t offset);

/* signal.c */
int handle_SIGIO_core(struct siginfo *info, struct sigcontext *sc);
const char *decode_trap(int code);
void set_timer(void);
void signal_init(void);

/* ssc.c */
unsigned long get_memsize(unsigned long *arg0);
long do_ssc(struct sigcontext *sc, long arg0, long arg1, long arg2, long arg3, int nr);

/* syscall.c */
void syscall_trace(void);
void tlbop(struct sigcontext *sc, int code, unsigned int r0, unsigned int r1);
void backtrace(struct sigcontext *sc);

/* aio.c */
int queueio(int fd, int seqno, int nreq, off_t offset, int is_write, struct disk_req *req);
void aio_init(int);
void aio_shutdown(void);
int aio_getcompletion(void);
int aio_wait_completion(struct disk_stat *ds);

/* cpuinfo.c */
unsigned long get_itc_freq(void);
