/*
 * Describe the virtual memory layout of the system.
 */

#ifndef VMLAYOUT_H
#define VMLAYOUT_H

#define KB	(1024)
#define MB	(KB*KB)
#define GB	(1024UL*MB)

/*
 * the fake `physical' memory runs from MEM_START to MEM_SIZE
 */
#define MEM_START	(512*KB)
/*
 * The low few pages are unmapped.
 * The virtual CPU structure lives at CPUADDR
 * This should be more than 2*PERCPU_PAGE_SIZE (128k)
 * and less than MEM_START
 */
#define CPUADDR		(256*KB)
#define START_ADDR      (0x200000000)
#define GATEADDR	(START_ADDR+0x200)
#endif /* VMLAYOUT_H */
